<?php

include '../../core.php';

checkAuth("pkiAdmin");

cabecera (3);

echo "<h1 class='title'>Exportaci&oacute;n de claves de Autoridades de Registro</h1>";

$command = $_POST['command'];
$errorCode = "a0";

switch ( $command ) {
   default :
      echo "<h3>Seleccióne la RA de la que quiera exportar su clave:</h3>";

      // Buscamos todas las RA disponible en el sistema
      $filter = "(objectClass=pkirisAuthority)";
      $justthese = array("pkirisName", "pkirisCopaID", "description");
      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);

      if (!$result)
         $errorCode = "a2b2c3d1e1";
      else if ( $result['count'] == 0 )
	 $errorCode = "a2b2c3d2e1";
      else {
         echo "<table border='0' cellpadding='0' cellspacing='0' !width='100%'>
         <tr>
         <td class='header'>Copa Id</td>
         <td class='header'>Nombre de la RA</td>
         <td class='header'>Descripci&oacute;n</td>
         </tr>\n";
        
         for($i = 0; $i < $result["count"]; $i++) {
            $queryCopa = $result[$i]["pkiriscopaid"][0];
            $queryRaName = $result[$i]["pkirisname"][0];
            $queryDescr = $result[$i]["description"][0];
	    echo "<form method='post' action='raPrivKey_export.php' enctype='multipart/form-data' name='RaKeyExport_form'>
                  <input type='hidden' name='copa' value='$queryCopa' />
                  <input type='hidden' name='command' value='have_copa' />\n";
            if ($i%2==0) {              
               echo "<tr>
                     <td class='even'> $queryCopa </td>
                     <td class='even'><input class='button2' type='submit' value='$queryRaName' /></td>
                     <td class='even'> $queryDescr </td></tr>
                     </form>\n";
            }
            else {
               echo "<tr>
                     <td class='odd'> $queryCopa </td>
                     <td class='odd'><input class='button2' type='submit' value='$queryRaName' /></td>
                     <td class='odd'> $queryDescr </td></tr>
                     </form>\n";
            }
	 }
         echo "</table>";
      }
      break;

      case "have_copa":
         $copa = $_POST['copa'];
         $currentDate = date("YmdHis");
         $r = exportRaPrivKey ($copa, $currentDate);
	 if ( !$r )
	    $errorCode = "a2b2c3d2e2";
	 else {
	    echo "<p>La clave de secreto compartido de la Autoridad de Registro \"$copa\" ha sido exportada con &eacute;xito.";
	    // Registramos la accion en el fichero de log
            $pkiLog['status'] = "exportRaKey";
            $pkiLog['eee'] = $copa;
            $pkiLog['user'] = "PKIAdmin";
            $pkiLog['error'] = $errorCode;
            writeLog ($pkiLog);
         }

      break;
}
	
// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error exportanto la clave de secreto compartido de la Autoridad de Registro</h2>\n";
   $pkiLog['status'] = "exportRaKey";
   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "PKIAdmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}
										      
pie ();

?>
